"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const notebook_1 = require("@jupyterlab/notebook");
require("../style/index.css");
require("codemirror/keymap/emacs.js");
/**
 * Initialization data for the jupyterlab_vim extension.
 */
const extension = {
    id: 'jupyterlab-emacskeys',
    autoStart: true,
    activate: activateCellEmacs,
    requires: [notebook_1.INotebookTracker]
};
class EmacsCell {
    constructor(app, tracker) {
        this._tracker = tracker;
        this._onActiveCellChanged();
        this._tracker.activeCellChanged.connect(this._onActiveCellChanged, this);
    }
    _onActiveCellChanged() {
        let activeCell = this._tracker.activeCell;
        if (activeCell !== null) {
            let editor = activeCell.editor;
            editor.setOption('keyMap', 'emacs');
            editor.setOption('extraKeys', {
                'Ctrl-/': 'undo',
                'Ctrl-Shift--': 'undo'
            });
        }
    }
}
function activateCellEmacs(app, tracker) {
    Promise.all([app.restored]).then(([args]) => {
        // tslint:disable:no-unused-expression
        new EmacsCell(app, tracker);
    });
    return Promise.resolve();
}
exports.default = extension;
